from Tkinter import *

DEBUGKEY='d'

#======================================================================#
# GUI class

class CDPlayerGUI(Frame):

 def __init__(self, parent, eventhandler):
   Frame.__init__(self, parent)
   self.parent = parent
   self.eventhandler=eventhandler
   self.createWidgets()
   self.b_eject.focus_force()
   parent.protocol("WM_DELETE_WINDOW", self.window_close)

 def window_close(self):
   self.eventhandler.event('GUI Quit')

 def key_stroke(self, e):
   self.eventhandler.event('GUI Debug')

 def eject_pressed(self):
   self.eventhandler.event('GUI Eject')

 def play_pressed(self):
   self.eventhandler.event('GUI Play/Pause')

 def stop_pressed(self):
   self.eventhandler.event('GUI Stop')

 def ffwd_pressed(self, e):
   self.eventhandler.event('GUI Forward Pressed')

 def ffwd_released(self, e):
   self.eventhandler.event('GUI Forward Released')

 def fbackwd_pressed(self, e):
   self.eventhandler.event('GUI Backward Pressed')

 def fbackwd_released(self, e):
   self.eventhandler.event('GUI Backward Released')

 def track_forward(self):
   self.eventhandler.event('GUI Track Forward')

 def track_back(self):
   self.eventhandler.event('GUI Track Backward')

 def createWidgets(self):

   f_left = Frame(self.parent)
   f_left.pack(side = LEFT)

   b_descr = Label(f_left, text='CDplay', 
                           height = 4, width= 12, 
			   fg="darkgreen", relief=GROOVE) 
   b_descr.pack(side = TOP)

   self.b_eject = Button(f_left, text='Eject', 
                            width = 10, 
			    command = self.eject_pressed )

   self.b_eject.pack(side = TOP)
   self.b_eject.bind(DEBUGKEY, self.key_stroke)

   f_right = Frame(self.parent)
   f_right.pack(side = RIGHT)

   f_row1 = Frame(f_right)
   f_row1.pack(side = TOP)
   self.b_playpause = Button(f_row1, text='Play/Pause', 
                               width=8, 
			       command = self.play_pressed)
   self.b_playpause.pack(side = LEFT)
   self.b_playpause.bind(DEBUGKEY, self.key_stroke)
   self.b_stop = Button(f_row1, text='Stop', 
                           width=8,
                           command = self.stop_pressed)
   self.b_stop.pack(side = LEFT)
   self.b_stop.bind(DEBUGKEY, self.key_stroke)

   f_row2 = Frame(f_right)
   f_row2.pack(side = TOP)

   self.b_fback = Button(f_row2, text='<<', 
                            width = 8)
   self.b_fback.bind('<Button-1>', self.fbackwd_pressed)
   self.b_fback.bind('<ButtonRelease-1>', self.fbackwd_released)
   self.b_fback.pack(side = LEFT)
   self.b_fback.bind(DEBUGKEY, self.key_stroke)

   self.b_ffwd = Button(f_row2, text='>>', 
                           width = 8)
   self.b_ffwd.bind('<Button-1>', self.ffwd_pressed)
   self.b_ffwd.bind('<ButtonRelease-1>', self.ffwd_released)
   self.b_ffwd.pack(side = LEFT)
   self.b_ffwd.bind(DEBUGKEY, self.key_stroke)

   f_row3 = Frame(f_right)
   f_row3.pack(side = TOP)

   self.b_tback = Button(f_row3, text='|<<', 
                            width = 8, 
	  		    command = self.track_back)
   self.b_tback.pack(side = LEFT)
   self.b_tback.bind(DEBUGKEY, self.key_stroke)

   self.b_tfwd = Button(f_row3, text='>>|', 
                           width = 8, 
		           command = self.track_forward)
   self.b_tfwd.pack(side = LEFT)
   self.b_tfwd.bind(DEBUGKEY, self.key_stroke)

   f_middle = Frame(self.parent, 
                     bg = 'black', relief = 'sunken', 
	             height = 100, width = 300, borderwidth = 1)
   f_middle.pack(side = TOP)

   Label(f_middle, text = "", bg = 'black',
	                      width = 20, borderwidth = 1).pack(side = TOP)

   self.timestr = StringVar()
   self.timestr.set('09:23')
   l_timestr = Label(f_middle, textvariable = self.timestr, bg = 'black', 
                           font='lucidasans-24',
	                   fg = 'green', width = 10, borderwidth = 1)
   l_timestr.pack()

   self.trackstr = StringVar()
   self.trackstr.set('[track 12]')
   l_trackstr = Label(f_middle, textvariable = self.trackstr, bg = 'black',
	                   fg = 'green', width = 20, borderwidth = 1)
   l_trackstr.pack(side = TOP)


   Label(f_middle, text = "", bg = 'black',
	                      width = 20, borderwidth = 1).pack(side = TOP)